unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, db, FileUtil, Forms, Controls, Graphics, Dialogs,
  StdCtrls, DBGrids, DbCtrls, ZConnection, ZDataset;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Datasource1: TDatasource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    MyConn: TZConnection;
    MyQuery: TZQuery;
    MyQuery2: TZQuery;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    function EstrapolaValoreNumero(stringa: string; pos: integer): string;
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
     MyConn.HostName:='localhost';
     MyConn.Database:=Application.Location + 'mydb.s3db';
     //MyConn.User:='tuo utente';
     //MyConn.Password:='tua password';
     MyConn.Protocol:='sqlite-3';
     MyConn.Connect;
     MyQuery2.SQL.Text:='SELECT Cognome, Nome, Eta FROM Tabella ORDER BY Id;';
     MyQuery2.Open;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
   appfile: TStringList;
   i: integer;
begin
     appfile:=TStringList.Create();
     appfile.LoadFromFile(Application.Location + 'testo.txt');
     for i:=0 to AppFile.Count-1 do
     begin
          MyQuery.SQL.Text:='';
          MyQuery.SQL.Add('INSERT INTO Tabella(Cognome, Nome, Eta)VALUES("' + StringReplace(EstrapolaValoreNumero(appFile.Strings[i],0),'''','''''', [rfReplaceAll]) + '","' + StringReplace(EstrapolaValoreNumero(appFile.Strings[i],1),'''','''''', [rfReplaceAll]) + '","' + StringReplace(EstrapolaValoreNumero(appFile.Strings[i],2),'''','''''', [rfReplaceAll]) + '");');
          MyQuery.ExecSQL;
     end;
     appfile.Free;
     { per fare il refresh della griglia }
     MyQuery2.Close;
     MyQuery2.Open;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     DBGrid1.Columns[0].Width:=80;
     DBGrid1.Columns[1].Width:=20;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
     MyQuery2.Close;
     MyConn.Disconnect;
end;

function TForm1.EstrapolaValoreNumero(stringa: string; pos: integer): string;
var
   MiaStringa: TStringList;
   ret: string;
begin
     ret:='';
     MiaStringa := TStringList.Create;
     MiaStringa.Delimiter := ';';
     MiaStringa.QuoteChar := '"';
     MiaStringa.DelimitedText := stringa;

     if ((pos>=0) AND (pos<MiaStringa.Count)) then
     begin
          ret:=MiaStringa[pos];
     end;
     MiaStringa.Free;
     EstrapolaValoreNumero:=ret;
end;


end.

